diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java b/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java
new file mode 100644
index 000000000..ee93d2583
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java
@@ -0,0 +1,485 @@
+package net.minecraft.client.gui.server;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.ScreenConnecting;
+import net.minecraft.client.gui.paged.Page;
+import net.minecraft.client.gui.paged.PageRegistry;
+import net.minecraft.client.gui.paged.ScreenPaged;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.gui.popup.PopupScreen;
+import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.texture.TextureBuffered;
+import net.minecraft.core.Global;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.ServerAddress;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
+import java.time.Instant;
+import java.util.Date;
+import java.util.UUID;
+
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
+import static org.lwjgl.opengl.GL11.glDisable;
+import static org.lwjgl.opengl.GL11.glEnable;
+
+public class ScreenSelectServer extends ScreenPaged {
+    public static final Texture defaultIcon = Minecraft.getMinecraft().textureManager.loadTexture("/assets/minecraft/textures/gui/unknown_server.png");
+    public static final @NotNull PageRegistry CREATE_WORLD_PAGES = new PageRegistry();
+    private static final ItemStack MAP = Items.MAP.getDefaultStack();
+    static {
+        MAP.getData().putBoolean("initialized", true);
+    }
+    public static final @NotNull DateFormat timeFormatter = new SimpleDateFormat();
+    public static final @NotNull Page PAGE_FAVORITES = CREATE_WORLD_PAGES.register(new Page("gui.select_server.page.favorites.title", Items.FLAG.getDefaultStack()));
+//    public static final @NotNull Page PAGE_INTERNET = CREATE_WORLD_PAGES.register(new Page("gui.select_server.page.internet.title", MAP));
+    public static final @NotNull Page PAGE_HISTORY = CREATE_WORLD_PAGES.register(new Page("gui.select_server.page.history.title", Items.BOOK.getDefaultStack()));
+    public static final @NotNull Page PAGE_LAN = CREATE_WORLD_PAGES.register(new Page("gui.select_server.page.lan.title", Items.DOOR_OAK.getDefaultStack()));
+    public static final @NotNull Page PAGE_DIRECT_CONNECT = CREATE_WORLD_PAGES.register(new Page("gui.select_server.page.direct_connect.title", Items.AMMO_ARROW_GOLD.getDefaultStack()));
+
+    private static final @NotNull StringBuilder stringBuilder = new StringBuilder(512);
+
+    public final @NotNull ServerManager serverManager;
+
+    public @Nullable ServerEntry selectedEntry = null;
+
+    public ButtonElement buttonJoin;
+//    public ButtonElement buttonDirectConnect;
+    public ButtonElement buttonAddServer;
+    public ButtonElement buttonEdit;
+    public ButtonElement buttonDelete;
+    public ButtonElement buttonRefresh;
+    public ButtonElement buttonCancel;
+
+    public @Nullable ServerAddress addressToJoin = null;
+    public ServerListenerThread listenerThread;
+    public boolean needToRefreshPages = false;
+
+    protected float panelScrollAmount = 0.0f;
+    protected int panelScrollRegionHeight;
+    protected @Nullable Float oldPanelScrollAmount = null;
+    protected float panelHeight = 100000;
+
+    public ScreenSelectServer(@Nullable Screen parent) {
+        super(parent, CREATE_WORLD_PAGES, PAGE_FAVORITES, "gui.select_server.label.title", new String[] {});
+
+        this.serverManager = ServerManager.getServerManager(this);
+        this.listenerThread = new ServerListenerThread(this);
+        this.listenerThread.start();
+
+        refreshPages();
+    }
+
+    @Override
+    public void init() {
+        super.init();
+
+        setupButtons();
+
+//        this.bottom = buttonJoin.yPosition - BUTTON_SPACING;
+//        this.rightScrollRegionHeight = this.bottom - this.top;
+//        this.leftScrollRegionHeight = this.bottom - this.top;
+    }
+
+    public void refreshPages() {
+//        PAGE_INTERNET.clearComponents();
+        PAGE_FAVORITES.clearComponents();
+        PAGE_HISTORY.clearComponents();
+        PAGE_LAN.clearComponents();
+        PAGE_DIRECT_CONNECT.clearComponents();
+        PAGE_DIRECT_CONNECT.withComponent(new SeverDirectConnectComponent(this));
+
+        serverManager.getFavorites().forEach(e -> PAGE_FAVORITES.withComponent(new ServerEntryComponent(this, e)));
+        serverManager.getLan().forEach(e -> PAGE_LAN.withComponent(new ServerEntryComponent(this, e)));
+        serverManager.getHistory().forEach(e -> PAGE_HISTORY.withComponent(new ServerEntryComponent(this, e)));
+//        serverManager.getInternet().forEach(e -> PAGE_INTERNET.withComponent(new ServerEntryComponent(this, e)));
+    }
+
+    public void setupButtons() {
+        if (selectedPage != PAGE_DIRECT_CONNECT) {
+            this.rightOffset = (int) (width * 0.25f);
+        } else {
+            this.rightOffset = 0;
+        }
+
+        buttons.clear();
+        I18n trans = I18n.getInstance();
+
+        int x1 = width / 2 - 154;
+        int y1 = height - 52;
+        int y2 = height - 24;
+
+        int w = width - rightOffset - leftWidth;
+
+        buttonJoin = add(new ButtonElement(0, width - rightOffset + 10, bottom - 22 * 3, rightOffset - 12, 20, trans.translateKey("gui.select_server.button.join_server")));
+        buttonEdit = add(new ButtonElement(3, width - rightOffset + 10, bottom - 22 * 2, rightOffset - 12, 20, trans.translateKey("gui.select_server.button.edit")));
+        buttonDelete = add(new ButtonElement(4, width - rightOffset + 10, bottom - 22, rightOffset - 12, 20, trans.translateKey("gui.select_server.button.delete")));
+
+        buttonAddServer = add(new ButtonElement(2, x1 + 208, y2, 100, 20, trans.translateKey("gui.select_server.button.add_server")));
+        buttonRefresh = add(new ButtonElement(5, x1 + 104, y2, 100, 20, trans.translateKey("gui.select_server.button.refresh")));
+        buttonCancel = add(new ButtonElement(6, x1, y2, 100, 20, trans.translateKey("gui.select_server.button.cancel")));
+
+        if (selectedPage == PAGE_DIRECT_CONNECT) {
+            buttonAddServer.enabled = buttonAddServer.visible = false;
+            buttonRefresh.enabled = buttonRefresh.visible = false;
+            buttonCancel.xPosition = (width - 100) / 2;
+        }
+
+        this.panelScrollRegionHeight = this.buttonJoin.yPosition - this.top;
+    }
+
+    @Override
+    protected void buttonClicked(@NotNull ButtonElement button) {
+        if (button == buttonCancel) {
+            this.mc.displayScreen(this.getParentScreen());
+            freeResources();
+        } /*else if (button == buttonDirectConnect) {
+            PopupScreen directConnect = new PopupBuilder(this, 160)
+                .withLabel("gui.select_server.popup.add.prompt.ip")
+                .withTextField("ip", "")
+                .withButtonGroup("1", new String[]{"gui.select_server.popup.direct.button.cancel", "gui.select_server.popup.direct.button.save"}, new int[]{0, 1})
+                .closeOnEsc(0)
+                .closeOnEnter(1)
+                .closeOnClickOut(0)
+                .withOnCloseListener((statusCode, results) -> {
+                    if (statusCode == 1) {
+                        String ip = (String) results.get("ip");
+                        ServerAddress address = ServerAddress.resolveServerIP(ip);
+                        if (address != null) {
+                            addressToJoin = address;
+                            if (serverManager.entryMap.containsKey(ip)) {
+                                serverManager.entryMap.get(ip).lastPlayedTime = System.currentTimeMillis();
+                            }
+                        }
+                    }
+                })
+                .build();
+            this.mc.displayScreen(directConnect);
+        }*/ else if (button == buttonAddServer) {
+            PopupScreen add = new PopupBuilder(this, 160)
+                .withLabel("gui.select_server.popup.add.prompt.name")
+                .withTextField("name", "")
+                .withLabel("gui.select_server.popup.add.prompt.ip")
+                .withTextField("ip", "")
+                .withButtonGroup("1", new String[]{"gui.select_server.popup.add.button.cancel", "gui.select_server.popup.add.button.save"}, new int[]{0, 1})
+                .withSwitch("showIp", true, "gui.select_server.popup.add.showip.on", "gui.select_server.popup.add.showip.off")
+                .closeOnEsc(0)
+                .closeOnEnter(1)
+                .closeOnClickOut(0)
+                .withOnCloseListener((statusCode, results) -> {
+                    if (statusCode == 1) {
+                        String name = (String) results.get("name");
+                        if (name.isEmpty()) name = null;
+                        ServerEntry entry = new ServerEntry(UUID.randomUUID(), (String) results.get("ip"));
+                        entry.overrideName = name;
+                        entry.showIp = (Boolean) results.get("showIp");
+                        entry.dirty = true;
+                        entry.requestIcon = true;
+                        serverManager.addEntry(entry);
+                        serverManager.addFavorite(entry);
+                        refreshPages();
+                    }
+                })
+                .build();
+            this.mc.displayScreen(add);
+        } else if (button == buttonEdit && selectedEntry != null) {
+            ServerEntry tEntry = selectedEntry;
+            PopupScreen edit = new PopupBuilder(this, 160)
+                .withLabel("gui.select_server.popup.edit.prompt.name")
+                .withTextField("name", tEntry.overrideName == null ? "" : tEntry.overrideName)
+                .withLabel("gui.select_server.popup.edit.prompt.ip")
+                .withTextField("ip", tEntry.address)
+                .withButtonGroup("1", new String[]{"gui.select_server.popup.edit.button.cancel", "gui.select_server.popup.edit.button.save"}, new int[]{0, 1})
+                .withSwitch("showIp", tEntry.showIp, "gui.select_server.popup.edit.showip.on", "gui.select_server.popup.edit.showip.off")
+                .closeOnEsc(0)
+                .closeOnEnter(1)
+                .closeOnClickOut(0)
+                .withOnCloseListener((statusCode, results) -> {
+                    if (statusCode == 1) {
+                        String name = (String) results.get("name");
+                        if (name.isEmpty()) name = null;
+                        tEntry.overrideName = name;
+                        tEntry.address = (String) results.get("ip");
+                        tEntry.addressResolved = null;
+                        tEntry.showIp = (Boolean) results.get("showIp");
+                        tEntry.dirty = true;
+                        tEntry.requestIcon = true;
+                        refreshPages();
+                    }
+                })
+                .build();
+            this.mc.displayScreen(edit);
+        } else if (button == buttonJoin) {
+            if (selectedEntry != null) {
+                needToRefreshPages = true;
+                serverManager.onJoined(selectedEntry);
+                joinServer(selectedEntry.getServerAddress());
+            }
+        } else if (button == buttonRefresh) {
+            refresh();
+        } else if (button == buttonDelete && selectedEntry != null) {
+            deleteEntry(selectedEntry);
+        }
+    }
+
+    private void scrollPanel(final float amount) {
+        if (amount == 0.0f) return;
+
+        this.panelScrollAmount += amount;
+        this.onScrollPanel();
+    }
+
+    private void onScrollPanel() {
+        final int totalPanelHeight = this.getTotalPanelHeight();
+        if (this.panelScrollAmount < 0 || this.panelScrollRegionHeight > totalPanelHeight) this.panelScrollAmount = 0;
+        else if (this.panelScrollAmount > totalPanelHeight - this.panelScrollRegionHeight)
+            this.panelScrollAmount = totalPanelHeight - this.panelScrollRegionHeight;
+    }
+
+    private int getTotalPanelHeight() {
+        return (int) panelHeight;
+    }
+
+    public void joinServer(@NotNull ServerAddress address) {
+        mc.gameSettings.lastServer.value = address.toString().replaceAll(":", "_");
+        mc.gameSettings.saveOptions();
+        mc.displayScreen(new ScreenConnecting(mc, address.getIP(), address.getPort()));
+        freeResources();
+    }
+
+    public void freeResources() { // Wonder how long until this not being called at the right time causes a memory leak :)
+        serverManager.freeResources();
+        listenerThread.keepAlive = false;
+    }
+
+    public void refresh() {
+        serverManager.idToEntryLock.lock();
+        try {
+            serverManager.idToEntryMap.forEach((uuid, entry) -> entry.dirty = true);
+        } finally {
+            serverManager.idToEntryLock.unlock();
+        }
+    }
+
+    @Override
+    public void tick() {
+        serverManager.idToEntryLock.lock();
+        try {
+            serverManager.idToEntryMap.values().stream().filter(entry -> entry.queuedIcon != null).forEach(entry -> {
+                entry.icon = new TextureBuffered(entry.queuedIcon, false, false, false);
+                entry.queuedIcon = null;
+            });
+        } finally {
+            serverManager.idToEntryLock.unlock();
+        }
+    }
+
+    public void deleteEntry(@NotNull ServerEntry entry) {
+        if (selectedPage == PAGE_FAVORITES) {
+            serverManager.removeFavorite(entry);
+        } else if (selectedPage == PAGE_HISTORY) {
+            serverManager.removeHistory(entry);
+        }
+        refreshPages();
+    }
+
+    @Override
+    public void handleScroll(int mx, int my, float partialTick) {
+        if (mx > this.width - rightOffset && mx < this.width) {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
+                this.scrollPanel(Mouse.getDWheel() / -0.01f);
+            } else {
+                this.scrollPanel(Mouse.getDWheel() / -0.05f);
+            }
+            this.onScrollPanel();
+            return;
+        }
+        super.handleScroll(mx, my, partialTick);
+    }
+
+    @Override
+    public void render(int mx, int my, float renderPartialTicks) {
+        if (addressToJoin != null) {
+            joinServer(addressToJoin);
+            return;
+        }
+        if (needToRefreshPages) {
+            needToRefreshPages = false;
+            refreshPages();
+        }
+
+        this.buttonJoin.visible = this.buttonJoin.enabled = selectedEntry != null;
+        this.buttonEdit.visible = this.buttonEdit.enabled = selectedEntry != null;
+        this.buttonDelete.visible = this.buttonDelete.enabled = selectedEntry != null;
+
+        super.render(mx, my, renderPartialTicks);
+
+        this.overlayBackground(this.width - rightOffset, this.width - rightOffset + SEPARATOR_WIDTH, this.top, this.bottom);
+        Scissor.enable(this.width - rightOffset, this.top, rightOffset, this.buttonJoin.yPosition - this.top);
+        renderSelectedEntry(mx, my, renderPartialTicks);
+        Scissor.disable();
+    }
+
+    protected void drawPanelScrollBar(final int mouseX, final int mouseY) {
+        int totalPanelHeight = getTotalPanelHeight();
+        final float scrollBarHeightPercent = (float) this.panelScrollRegionHeight / totalPanelHeight;
+
+        if (scrollBarHeightPercent > 1.0f) return;
+
+        glDisable(GL_TEXTURE_2D);
+
+        final int scrollBarX = this.width - 6;
+
+        int scrollBarHeightPx = (int) (scrollBarHeightPercent * this.panelScrollRegionHeight);
+        if (scrollBarHeightPx < 32) {
+            scrollBarHeightPx = 32;
+        }
+
+        final float scrollPercent = this.panelScrollAmount / (totalPanelHeight - this.panelScrollRegionHeight);
+
+        final int scrollBarY = (int) (this.top + (this.panelScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
+
+        final @NotNull Tessellator t = Tessellator.instance;
+
+        t.startDrawingQuads();
+        t.setColorOpaque(0, 0, 0);
+        t.drawRectangle(scrollBarX, this.top, 6, this.panelScrollRegionHeight);
+        t.setColorRGBA_I(0x808080, 255);
+        t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
+        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
+        t.draw();
+
+        glEnable(GL_TEXTURE_2D);
+
+        if (this.clickX != null && this.clickY != null) {
+            if (this.clickX >= scrollBarX && this.clickY >= this.top && this.clickX <= scrollBarX + 6 && this.clickY < this.bottom) {
+                if (this.oldPanelScrollAmount == null) {
+                    this.oldPanelScrollAmount = this.panelScrollAmount;
+                }
+                this.panelScrollAmount = this.oldPanelScrollAmount + (this.clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
+                this.onScrollPanel();
+            }
+        } else {
+            this.oldPanelScrollAmount = null;
+        }
+    }
+
+    public void renderSelectedEntry(int mx, int my, float partialTick) {
+        if (selectedEntry != null) {
+            int totalPanelHeight = getTotalPanelHeight();
+            final float scrollBarHeightPercent = (float) this.panelScrollRegionHeight / totalPanelHeight;
+
+            Tessellator t = Tessellator.instance;
+            int minX = this.width - rightOffset + SEPARATOR_WIDTH;
+            int maxX = this.width;
+            int y = (int) (top + 4 - panelScrollAmount);
+            int startY = y;
+            if (selectedEntry.icon != null) {
+                selectedEntry.icon.bind();
+                t.startDrawingQuads();
+                t.drawRectangleWithUV(minX + (maxX - minX - 64)/2, y, 64, 64, 0, 0, 1, 1);
+                y += 64 + 2;
+                t.draw();
+            }
+
+            stringBuilder.setLength(0);
+            if (selectedEntry.showIp) {
+                stringBuilder.append(TextFormatting.GRAY).append(selectedEntry.getServerAddress().getIP()).append(":").append(selectedEntry.getServerAddress().getPort()).append(TextFormatting.RESET).append("\n");
+            }
+//            builder.append(TextFormatting.GRAY);
+            stringBuilder.append(selectedEntry.getName("Unknown"));
+            if (selectedEntry.version != null) {
+                stringBuilder.append(TextFormatting.RESET).append("\n\n");
+                stringBuilder.append(selectedEntry.protocolVersion == Global.MP_PROTOCOL_VERSION ? TextFormatting.YELLOW : TextFormatting.RED).append(selectedEntry.version);
+            }
+            stringBuilder.append(TextFormatting.RESET).append("\n\n");
+            if (selectedEntry.motd != null) {
+                stringBuilder.append(selectedEntry.motd);
+            }
+            if (!selectedEntry.players.isEmpty()) {
+                stringBuilder.append(TextFormatting.RESET).append("\n\n");
+                stringBuilder.append("Players:\n");
+                for (int i = 0; i < selectedEntry.players.size(); i++) {
+                    stringBuilder.append(" - ").append(TextFormatting.GRAY).append(selectedEntry.players.get(i)).append(TextFormatting.RESET).append("\n");
+                }
+            }
+            if (selectedEntry.lastPlayedTime >= 0) {
+                stringBuilder.append(TextFormatting.RESET).append("\n\n");
+                stringBuilder.append("Last Played: ").append(timeFormatter.format(Date.from(Instant.ofEpochMilli(selectedEntry.lastPlayedTime))));
+            }
+            mc.font.renderWidthConstrained(t, stringBuilder, minX + 2, y, maxX - minX - 4 - ((scrollBarHeightPercent > 1.0f) ? 0 : 6)).setShadow().call();
+            panelHeight = (float) (mc.font.getLastEndingY() - startY) + 8;
+
+            drawPanelScrollBar(mx, my);
+        }
+    }
+
+    @Override
+    public void onPageChanged(@NotNull Page lastPage, @NotNull Page newPage) {
+        setSelectedEntry(null);
+        setupButtons();
+    }
+
+    public void setSelectedEntry(@Nullable ServerEntry entry) {
+        this.selectedEntry = entry;
+        this.panelScrollAmount = 0;
+        this.oldPanelScrollAmount = null;
+        this.panelHeight = 0;
+    }
+
+    @Override
+    public void renderBackground() {
+        if (this.mc.currentWorld == null) {
+            this.renderTexturedBackground();
+            final @NotNull Tessellator tessellator = Tessellator.instance;
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            final float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x202020);
+
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (float) (this.bottom + (int) this.rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width - rightOffset, this.bottom, 0.0D, (float) (this.width - rightOffset) / scale, (this.bottom + this.rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width - rightOffset, this.top, 0.0D, (float) (this.width - rightOffset) / scale, (this.top + this.rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, (float) (this.top + (int) this.rightScrollAmount) / scale);
+
+            tessellator.addVertexWithUV(this.width - rightOffset, this.bottom, 0.0D, (this.width - rightOffset) / scale, (this.bottom + this.panelScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, (float) (this.width) / scale, (this.bottom + this.panelScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width, this.top, 0.0D, (float) (this.width) / scale, (this.top + this.panelScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width - rightOffset, this.top, 0.0D, (this.width - rightOffset) / scale, (this.top + this.panelScrollAmount) / scale);
+
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (this.bottom + this.leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.leftWidth, this.bottom, 0.0D, (float) this.leftWidth / scale, (this.bottom + this.leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.leftWidth, this.top, 0.0D, (float) this.leftWidth / scale, (this.top + this.leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, (this.top + this.leftScrollAmount) / scale);
+
+            tessellator.draw();
+        } else {
+            final int color = this.mc.gameSettings.guiBackgroundColor.value.getARGB();
+            this.drawGradientRect(0, 0, this.width, this.height, color, color);
+            this.drawRect(0, 0, this.width, this.top, 0x5F000000);
+            this.drawRect(0, this.bottom, this.width, this.height, 0x5F000000);
+            this.drawRect(this.leftWidth, this.top, this.leftWidth + SEPARATOR_WIDTH, this.bottom, 0x5F000000);
+        }
+    }
+
+    @Override
+    public void removed() {
+        super.removed();
+        ServerManager.saveServerManager(serverManager);
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntry.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntry.java
new file mode 100644
index 000000000..aa505df8b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntry.java
@@ -0,0 +1,66 @@
+package net.minecraft.client.gui.server;
+
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.core.net.ServerAddress;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.awt.image.BufferedImage;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+import java.util.UUID;
+
+public class ServerEntry {
+    public @NotNull UUID uuid;
+    public @Nullable String overrideName;
+    public @Nullable String baseName;
+    public @Nullable String motd;
+    public @NotNull String address;
+    public @Nullable ServerAddress addressResolved;
+    public @Nullable Texture icon;
+    public @Nullable BufferedImage queuedIcon; // Exists because only the main thread can manifest Textures
+
+    public int playerCount;
+    public int playerCap;
+    public @NotNull List<String> players = new ArrayList<>();
+
+    public @Nullable String version;
+    public int protocolVersion = -1;
+
+    public long ping;
+    public long lastPlayedTime = -1;
+
+    public boolean isUp = false;
+
+    public boolean showIp = false;
+
+    public boolean requestIcon = false;
+    public boolean dirty = false;
+
+    public ServerEntry(@NotNull UUID uuid, @NotNull String address) {
+        this.uuid = uuid;
+        this.address = address;
+        this.icon = ScreenSelectServer.defaultIcon;
+    }
+
+    public @NotNull String getName(@NotNull String defaultName) {
+        if (overrideName != null && !overrideName.isBlank()) return overrideName;
+        if (baseName != null && !baseName.isBlank()) return baseName;
+        return defaultName;
+    }
+
+    public void free() {
+        if (icon != null && icon != ScreenSelectServer.defaultIcon) {
+            icon.delete();
+            icon = null;
+        }
+    }
+
+    public @NotNull ServerAddress getServerAddress() {
+        if (addressResolved == null) {
+            this.addressResolved = Objects.requireNonNull(ServerAddress.resolveServerIP(this.address));
+        }
+        return addressResolved;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
new file mode 100644
index 000000000..6a905276a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
@@ -0,0 +1,95 @@
+package net.minecraft.client.gui.server;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.render.font.Alignment;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.Global;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
+
+public class ServerEntryComponent implements PageComponent {
+    private static final StringBuilder stringBuilder = new StringBuilder(512);
+    public final @NotNull ServerEntry entry;
+    public final @NotNull Minecraft mc;
+    public final @NotNull ScreenSelectServer attachedScreen;
+    public ServerEntryComponent(@NotNull ScreenSelectServer attachedScreen, @NotNull ServerEntry entry) {
+        this.entry = entry;
+        this.mc = Minecraft.getMinecraft();
+        this.attachedScreen = attachedScreen;
+    }
+
+    @Override
+    public int getHeight() {
+        return 26;
+    }
+
+    @Override
+    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        Tessellator t = Tessellator.instance;
+        if (entry.icon != null) {
+            entry.icon.bind();
+            t.startDrawingQuads();
+            t.drawRectangleWithUV(x + 1, y + 1, 24, 24, 0, 0, 1, 1);
+            t.draw();
+        }
+
+        mc.font.render(t, entry.getName("Unknown"), x + 24 + 3, y + 2).setShadow().call();
+        if (entry.motd != null) {
+            stringBuilder.setLength(0);
+            stringBuilder.append(TextFormatting.GRAY).append(entry.motd);
+            stringBuilder.setLength(Math.max((width - 16), 0) / mc.font.getFont().charWidth('m'));
+            mc.font.renderWidthConstrained(t, stringBuilder, x + 24 + 3, mc.font.getLastEndingY(), width).setShadow().call();
+        }
+
+        if (!entry.isUp) {
+            stringBuilder.setLength(0);
+            stringBuilder.append(I18n.getInstance().translateKey("gui.select_server.label.down"));
+            mc.font.renderWidthConstrained(t, stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
+        } else if (entry.protocolVersion != Global.MP_PROTOCOL_VERSION) {
+            stringBuilder.setLength(0);
+            stringBuilder.append(I18n.getInstance().translateKey("gui.select_server.label.outdated"));
+            mc.font.renderWidthConstrained(t, stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
+//            stringBuilder.setLength(0);
+//            stringBuilder.append(entry.version);
+//            mc.font.renderWidthConstrained(t, stringBuilder, x, mc.font.getLastEndingY(), width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
+        } else if (!entry.dirty) {
+            stringBuilder.setLength(0);
+            stringBuilder.append(entry.playerCount).append("/").append(entry.playerCap);
+            mc.font.renderWidthConstrained(t, stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFFFF00).setAlignment(Alignment.RIGHT).call();
+            stringBuilder.setLength(0);
+            stringBuilder.append(entry.ping).append(" ms");
+            mc.font.renderWidthConstrained(t, stringBuilder, x, mc.font.getLastEndingY(), width - 2).setShadow().setColor(0xFFFF00).setAlignment(Alignment.RIGHT).call();
+        }
+
+        if (entry == attachedScreen.selectedEntry) {
+            attachedScreen.drawBox(x, y, x + width, y + getHeight(), 0xFFFFFFFF, 1);
+        }
+    }
+
+    @Override
+    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        attachedScreen.setSelectedEntry(entry);
+    }
+
+    @Override
+    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+
+    }
+
+    @Override
+    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+
+    }
+
+    @Override
+    public void onKeyPress(int keyCode, char character) {
+
+    }
+
+    @Override
+    public boolean matchesSearchTerm(String term) {
+        return false;
+    }
+}
